(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: DISK.PAS                                                       *)
(*  Obsah: veci pro praci se soubory a par diagnostickych procedur         *)
(*  Posledni uprava: 30.7.2007                                             *)
(*  Autor: Mircosoft (http://mircosoft.ic.cz)                              *)
(*         TrSek (diagnostika, reset)                                      *)
(*         FReeZ (detekce Windows 9x)                                      *)
(*  Pro kompilaci: (DOS.TPU)                                               *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
unit Disk;
{$I-} {nutne, nemazat!}
interface
uses dos;

function ZkratCestu(C:pathstr;PocetZnaku:byte):pathstr;
{pokud je retezec C delsi nez PocetZnaku, zkrati se tak, ze misto zacatku
budou tri tecky. Vicemene pro kosmeticke ucely, treba pro zobrazovani jmen
souboru na obrazovku na nejaky omezeny prostor tak, aby to nejdulezitejsi -
jmeno souboru - zustalo citelne. Priklad:
 zkratcestu('c:\programy\doom\data\soubor.exe',20)
vrati retezec '...m\data\soubor.exe'}
procedure NastavDisk(dsk:char);
{prepne na dany disk (napr. 'c', 'a' apod., nerozlisuji se velka a mala
pismena)}
function ExistujeSoubor(Jmeno:string):boolean;
{Zjisti, jestli existuje soubor s danym Jmenem. Da se testovat i existence
vice souboru najednou, pak do Jmena napiste jmena vice souboru a oddelte je
carkami (bez mezer):
 if not existujesoubor('soubor1.bla,neco.txt,dalsi.dat')
   then writeln('Jeden nebo vice z tech souboru neexistuje.');}
function ExistujeAdresar(jmeno:pathstr):boolean;
{zjisti, jestli existuje dany adresar. Nerucim za 100% funkcnost u skrytych
adresaru a podobne, ale jinak by mela fungovat bezpecne.}
function Kopiruj(zdroj,cil:pathstr):boolean;
{Kopiruje soubor zdroj do souboru cil. Pokud cil existuje,bude prepsan.
Vraci true, pokud se kopirovani povedlo.}
function AdresarProgramu:dirstr;
{vraci adresar, ze ktereho byl prave bezici program spusten}
function JmenoSouboru(soubor:pathstr):namestr;
{vraci jmeno souboru bez cesty a koncovky}
function MaMechanikuA:boolean;
function MaMechanikuB:boolean;
{true v pripade, ze dana mechanika existuje, ani v ni nemusi byt disketa}
function TypDisku(ktereho:char):byte;
{vysledek: 0 = neexistuje, 1 = disketa, 2 = harddisk, 3 = sitovy disk,
4 = prazdna disketova mechanika}
procedure ResetujPocitac;
{Zpusobi "teply restart" (ekvivalent ctrl+alt+del), funguje jen pod DOSem.}
function VymazSoubor(s:pathstr):boolean;
{vymaze soubor, vraci true, pokud se to povedlo, jinak false}
function SifrujSoubor(Zdroj,Cil:pathstr; Heslo:string):boolean;
{Obsah souboru Zdroj prekopiruje v zasifrovane podobe do souboru Cil. Koduje
se jednoduchym, ale ucinnym xorovanim kazdeho bytu vstupniho souboru s jednim
znakem Hesla, z cehoz mimo jine vyplyva, ze zakodovani i rozkodovani se dela
tou samou procedurou (protoze A xor B xor B = A).
Pokud se za behu procedury vyskytne jakakoli chyba (neexistujici soubor,
nezadane heslo atd.), vraci se False, jinak True.
Teoreticky detail: pokud je heslo stejne dlouhe jako sifrovany soubor a je
slozeno z dostatecne nahodnych (neuhodnutelnych) znaku, je tato sifra dokonale
neprolomitelna (dukaz je celkem jednoduchy).}

type{pro nasledujici proceduru}
string3=string[3];
UkNaTSoubor=^TSoubor;
TSoubor=record
        jmeno:string[8];{jmeno a koncovka jsou zvlast, protoze se s tim pak lip pracuje}
        koncovka:string3;{koncovka je bez predchazejici tecky}
        atributy:byte;
        velikost:longint;{v bytech}
        zmeneno:longint;{na rozbaleni casu je Unpacktime}
        dalsi:uknatsoubor;{bude to ve spojovem seznamu}
        end;
procedure SeznamSouboru(var prvni:uknatsoubor;koncovky:string3);
{Prohleda aktualni adresar a vytvori seznam souboru, ktere v nem najde,
abecedne setrideny podle nazvu. Vyhledava vsechny soubory vcetne skrytych.
Jestli je po skonceni procedury Doserror=-1, byl nedostatek pameti a seznam
neni uplny.
 prvni - bude ukazovat na zacatek seznamu souboru
 koncovky - jaky typ souboru se ma hledat. Priklad: 'txt', '*' (jakakoli
            koncovka), '' (bez koncovky) apod. Piste bez tecky.}
procedure ZrusSeznamSouboru(var prvni:uknatsoubor);
{vymaze z pameti seznam vytvoreny procedurou SeznamSouboru}

type{pro nasledujici proceduru}
UkNaTAdresar=^TAdresar;
TAdresar=record
         jmeno:string[8];{predpokladam jmena adresaru bez koncovky}
         atributy:byte;
         zmeneno:longint;
         dalsi:uknatadresar;
         end;
procedure SeznamAdresaru(var prvni:uknatadresar);
{Podobna, ale dela seznam adresaru. Pokud existuje adresar '..' (da se jit o
uroven vys), bude v seznamu zaclenen na prvnim miste.}
procedure ZrusSeznamAdresaru(var prvni:uknatadresar);
{vymaze seznam z pameti}

type{pro nasledujici proceduru}
UkNaAUzel=^auzel;
AUzel=record
      jmeno:string[12];
      dalsi,{dalsi jeho kolega nachazejici se ve stejnem adresari}
      obsah:uknaauzel;{seznam jeho podadresaru}
      end;
procedure StromAdresaru(var cil:uknaauzel; cesta:pathstr);
{Za ukazatelem Cil vytvori stromovou strukturu adresaru, ktere zacinaji v
adresari Cesta. Pozor: Cesta MUSI byt vyplnena, a to tak, aby nekoncila
znakem '\'. Takze napr.: 'c:', 'c:\windows', 'c:\tp\bin' apod.. Nelze zadat
prazdnou ('')!}
procedure ZrusStromAdresaru(var ktery:uknaauzel);
{zrusi drive vytvoreny strom adresaru}
procedure HromadneAtributy(maska:pathstr; jake:word);
{Nastavi dane atributy vsem souborum ve vsech podadresarich aktualniho
adresare (aktualni adresar ovlivnen nebude). Maska je napr. '*.*', '*.exe'
apod. (bez cesty!). Pouzitelne hodnoty pro Jake jsou: Archive, ReadOnly,
Hidden a SysFile, daji se scitat (nebo ORovat) - viz napovedu.}
function Win9XAktivni:boolean;
{zjisti, jestli bezi Windows 95 nebo 98}

implementation

function ZkratCestu(C:pathstr;PocetZnaku:byte):pathstr;
Begin
if byte(c[0])>pocetznaku then{pokud je delka retezce C vetsi nez pozadovany pocet znaku}
  begin
  delete(c,1,byte(c[0])-pocetznaku);{vymazani prebytecnych znaku ze zacatku retezce}
  if byte(c[0])>3 then fillchar(c[1],3,'.');{nahrzeni prvnich tri znaku teckami}
  end;
zkratcestu:=c;
End;{zkratcestu}

procedure nastavdisk(dsk:char);
var b:byte;
Begin
b:=ord(upcase(dsk))-65;
asm
mov DL,b
mov AH,$0E
int $21
end;
End;{nastavdisk}

function existujesoubor(jmeno:string):boolean;
var f:file;
    i:byte; {index pro pohyb v retezci}
Begin
existujesoubor:=true;
 repeat
 {i nastavime tak, aby ukazovalo na posledni znak pred carkou
 nebo pred koncem retezce:}
 i:=1;
 while (i<byte(jmeno[0]))and(jmeno[i+1]<>',') do inc(i);
 {pokusne otevreni a zavreni souboru:}
 assign(f,copy(jmeno,1,i));
 reset(f);
 close(f);
 if ioresult<>0 then begin {jestli pri otvirani nastala chyba, soubor zrejme neexistuje}
                     existujesoubor:=false;
                     break;
                     end;
 delete(jmeno,1,i+1);{vymazani zpracovaneho jmena z retezce vcetne pripadne carky za nim}
 until jmeno='';{dokud neni zpracovan cely retezec}
End;{existujesoubor}

function ExistujeAdresar(jmeno:pathstr):boolean;
var info:searchrec;
Begin
findfirst(jmeno,directory,info);{slo by to testovat i tak, ze bych se do toho
adresare zkusil prepnout a pak se zase vratit,ale mam s tim spatne zkusenosti}
existujeadresar:=doserror=0;
End;{existujeadresar}

function kopiruj(zdroj,cil:pathstr):boolean;
var FromF,ToF:file;
    NumRead,NumWritten:Word;
    Buf:array[1..2048] of byte;
Begin                               {viz napovedu k prikazu blockwrite}
Assign(FromF,zdroj);
Reset(FromF,1);
if ioresult=0 then begin
                   Assign(ToF,cil);
                   Rewrite(ToF,1);
                   if ioresult=0 then begin
                                       repeat
                                       BlockRead(FromF,Buf,SizeOf(Buf),NumRead);
                                       BlockWrite(ToF,Buf,NumRead,NumWritten);
                                       until (NumRead=0) or (NumWritten<>NumRead);
                                      Close(FromF);
                                      Close(ToF);
                                      kopiruj:=true;
                                      end
                                 else begin
                                      close(fromf);
                                      kopiruj:=false;
                                      end;
                   end
              else kopiruj:=false;
End;{kopiruj}

function AdresarProgramu:dirstr;
var cesta:dirstr; jmeno:namestr; koncovka:extstr;
Begin
fsplit(paramstr(0),cesta,jmeno,koncovka);
adresarprogramu:=cesta;
End;{adresarprogramu}

function JmenoSouboru(soubor:pathstr):namestr;
var cesta:dirstr; jmeno:namestr; koncovka:extstr;
Begin
fsplit(soubor,cesta,jmeno,koncovka);
jmenosouboru:=jmeno;
End;{jmenosouboru}

function MaMechanikuA:boolean; assembler;
Asm
int $11
and AX,1
End;{mamechanikua}

function MaMechanikuB:boolean; assembler;
Asm
int $11
and AX,$C0
End;{mamechanikub}

function TypDisku(ktereho:char):byte;
var regAH:byte; regDX:word; cislo:byte;
Begin
cislo:=ord(upcase(ktereho))-64;
if cislo=1 then begin{A:}
                if mamechanikua then if diskfree(cislo)<0 then typdisku:=4{v mechanice neni disketa}
                                                          else typdisku:=1{v mechanice je disketa}
                                else typdisku:=0;{mechanika vubec neexistuje}
                end
 else if cislo=2 then begin{B:}
                      if mamechanikub then if diskfree(cislo)<0 then typdisku:=4
                                                                else typdisku:=1
                                      else typdisku:=0;
                      end
  else begin
       asm
       mov AX,$440F
       mov BL,cislo
       int $21
       mov regAH,AH
       end;
       if(regAH<>0)or(disksize(cislo)<0)then typdisku:=0{disk neexistuje}
                                        else begin{existuje}
                                             asm
                                             mov AX,$4409
                                             mov BL,cislo
                                             int $21
                                             mov regDX,DX
                                             end;
                                             if (RegDX and $1000)=$1000 then typdisku:=3{network drive}
                                                                        else typdisku:=2;{harddisk}
                                             end;
       end;
End;{typdisku}

procedure ResetujPocitac;
var reboot:procedure;
Begin
@reboot:=Ptr($FFFF,$0); {adresa bootovaciho programu}
reboot;
End;{resetujpocitac}

function VymazSoubor(s:pathstr):boolean;
var f:file;
Begin
assign(f,s);
erase(f);
vymazsoubor:=ioresult=0;
End;{vymazsoubor}

function SifrujSoubor(zdroj,cil:pathstr;heslo:string):boolean;
var f1,f2:file;
    bafr:array[1..1024]of byte;{bude se cist a psat po kilobytech}
    precteno,{kolik B bylo precteno ze vstupniho souboru}
    zapsano:word;{kolik B se podarilo zapsat do vystupniho souboru}
    i:word;{index pro pohyb v bufferu}
    j:byte;{index pro pohyb v heslu}
Begin
sifrujsoubor:=false;{zatim nevime, jestli vsechno dobre dopadne}
if heslo='' then exit;{prazdnym heslem by sifrovat neslo}
j:=1;{zacit se musi vzdy od prvniho znaku hesla}
assign(f1,zdroj); assign(f2,cil);{priradime promennym soubory}
reset(f1,1);{otevreme vstup}
if ioresult=0 then{kdyz to dobre dopadlo, tak pokracujeme}
  begin
  rewrite(f2,1);{otevreme vystup}
  if ioresult=0 then{kdyz to dobre dopadlo, tak pokracujeme, jinak...*}
    begin
     repeat
     blockread(f1,bafr,1024,precteno);{nacti 1024 bytu ze souboru f1, uloz je do bafru a do promenne Precteno uloz,
                                       kolik se jich ve skutecnosti podarilo precist}
     if precteno>0 then
      for i:=1 to precteno do begin{kodovani}
                              bafr[i]:=bafr[i] xor byte(heslo[j]);{a tohle je cely sifrovaci algoritmus :-)}
                              if j<byte(heslo[0]) then inc(j){a posuneme se v heslu bud na dalsi znak...}
                                                  else j:=1;{...nebo zpatky na zacatek, pokud uz jsme byli na konci}
                              end;
     blockwrite(f2,bafr,precteno,zapsano);{zapis z bafru do f2 tolik bytu, kolik jsi jich predtim nacetl z f1
                                           a do promenne Zapsano uloz, kolik se ti jich povedlo doopravdy zapsat}
     until (precteno<1024){jsme na konci vstupniho souboru}
        or(zapsano<precteno);{nebo doslo misto na disku s vystupnim souborem}
    close(f1); close(f2);{zavreme soubory}
    if (zapsano=precteno)and(ioresult=0)then sifrujsoubor:=true;{a jestli tohle vsechno dobre dopadlo, tak ohlasime,
                                                                 ze je vse v poradku}
    end
                else begin
                     close(f1);{*...zase zavreme vstup a koncime}
                     i:=ioresult;{to uz jen pro jistotu, aby se ioresult vynuloval po pripadnem neuspesnem zavreni}
                     end;
  end;
End;{sifrujsoubor}

procedure SeznamSouboru(var prvni:uknatsoubor; koncovky:string3);
var vybrany,novy,predchozi:uknatsoubor;
    vysledek:searchrec;
    maska:string[5];
    _cesta:dirstr; _jmeno:namestr; _koncovka:extstr;
Begin
prvni:=nil;
if koncovky='' then maska:='*' else maska:='*.'+koncovky;
findfirst(maska,anyfile,vysledek);
while doserror=0 do{dokud je neco nalezeno...}
 begin
 if (vysledek.attr and directory)=0 then{...a neni to adresar (ma se delat seznam souboru, ne adresaru)}
  begin
  if sizeof(tsoubor)>maxavail then doserror:=-1{tohle neni zadny oficialni kod, jenom potrebuju nejak jednoduse nahlasit,
                                                ze bylo malo pameti a procedura tedy nedobehla}
                              else
    begin
    new(novy);
    fsplit(vysledek.name,_cesta,_jmeno,_koncovka);
    with novy^ do begin
                  jmeno:=_jmeno;
                  if (_koncovka<>'')and(_koncovka[1]='.') then delete(_koncovka,1,1);{umazani tecky z koncovky}
                  koncovka:=_koncovka;
                  atributy:=vysledek.attr;
                  velikost:=vysledek.size;
                  zmeneno:=vysledek.time;
                  end;
    {zarazeni do seznamu:}
    if prvni=nil then begin
                      prvni:=novy;
                      prvni^.dalsi:=nil;
                      end
                 else begin
                      vybrany:=prvni; predchozi:=nil;
                      while (vybrany<>nil)and(vybrany^.jmeno<novy^.jmeno) do
                        begin
                        predchozi:=vybrany;
                        vybrany:=vybrany^.dalsi;
                        end;
                      if predchozi=nil then begin {uplne na zacatek}
                                            novy^.dalsi:=prvni;
                                            prvni:=novy;
                                            end
                                       else begin {mezi predchozi a vybrany}
                                            novy^.dalsi:=vybrany;
                                            predchozi^.dalsi:=novy;
                                            end;
                      end;
    end;{if}
  end;{if}
 if doserror<>-1 then findnext(vysledek);
 end;{while}
End;{seznamsouboru}

procedure ZrusSeznamSouboru(var prvni:uknatsoubor);
var pom:uknatsoubor;
Begin
while prvni<>nil do begin
                    pom:=prvni;
                    prvni:=prvni^.dalsi;
                    dispose(pom);
                    end;
End;{zrusseznamsouboru}

procedure SeznamAdresaru(var prvni:uknatadresar);
var vybrany,novy,predchozi:uknatadresar;
    vysledek:searchrec;
Begin
prvni:=nil;
findfirst('*',anyfile,vysledek);
while doserror=0 do{dokud je neco nalezeno...}
 begin
 if ((vysledek.attr and directory)=directory)and(vysledek.name<>'.') {adresar jiny nez ten, ve kterem zrovna jsme}
   then if sizeof(tadresar)>maxavail
          then doserror:=-1
          else begin
               new(novy);
               with novy^ do begin
                             jmeno:=vysledek.name;
                             atributy:=vysledek.attr;
                             zmeneno:=vysledek.time;
                             end;
               if prvni=nil then begin
                                 prvni:=novy;
                                 prvni^.dalsi:=nil;
                                 end
                            else begin
                                 vybrany:=prvni; predchozi:=nil;
                                 while (vybrany<>nil)and((vybrany^.jmeno='..')or(vybrany^.jmeno<novy^.jmeno)) do
                                   begin
                                   predchozi:=vybrany;
                                   vybrany:=vybrany^.dalsi;
                                   end;
                                 if predchozi=nil then begin {uplne na zacatek}
                                                       novy^.dalsi:=prvni;
                                                       prvni:=novy;
                                                       end
                                                  else begin {mezi predchozi a vybrany nebo na konec}
                                                       novy^.dalsi:=vybrany;
                                                       predchozi^.dalsi:=novy;
                                                       end;
                                 end;
               end;
 if doserror<>-1 then findnext(vysledek);
 end;
End;{seznamadresaru}

procedure ZrusSeznamAdresaru(var prvni:uknatadresar);
var pom:uknatadresar;
Begin
while prvni<>nil do begin
                    pom:=prvni;
                    prvni:=prvni^.dalsi;
                    dispose(pom);
                    end;
End;{zrusseznamadresaru}

procedure StromAdresaru(var cil:uknaauzel; cesta:pathstr);
{}procedure novyuzel(var kde:uknaauzel; njmeno:string);
{}Begin
{}new(kde);
{}with kde^ do begin
{}             jmeno:=njmeno;
{}             dalsi:=nil; obsah:=nil;
{}             end;
{}End;{novyuzel}
var sr:searchrec;
    pom:uknaauzel;
Begin
{vytvoreni seznamu adresaru:}
findfirst(cesta+'\*',anyfile,sr);
while doserror=0 do
  begin
  if ((sr.attr and directory)<>0)and(sr.name[1]<>'.') then {je to adresar a neni to aktualni ani predchozi}
    {zarazeni do seznamu:}
    if cil=nil then begin
                    novyuzel(cil,sr.name);
                    pom:=cil;
                    end
               else begin
                    novyuzel(pom^.dalsi,sr.name);
                    pom:=pom^.dalsi;
                    end;
  findnext(sr);
  end;
{vyreseni podadresaru od kazdeho adresare v seznamu:}
pom:=cil;
while pom<>nil do begin
                  stromadresaru(pom^.obsah,cesta+'\'+pom^.jmeno);
                  pom:=pom^.dalsi;
                  end;
End;{stromadresaru}

procedure ZrusStromAdresaru(var ktery:uknaauzel);
var pom:uknaauzel;
Begin
while ktery<>nil do begin
                    zrusstromadresaru(ktery^.obsah);
                    pom:=ktery;
                    ktery:=ktery^.dalsi;
                    dispose(pom);
                    end;
ktery:=nil;
End;{zrusstromadresaru}

procedure HromadneAtributy(maska:pathstr; jake:word);
var sa:uknaauzel;
    PocatecniCesta:pathstr;{cesta do aktualniho adresare bez \ na konci}
{}procedure NastavJe(kde:uknaauzel; cesta:pathstr);
{}var f:file;
{}    sr2:searchrec;
{}Begin
{}while kde<>nil do begin
{}                  findfirst(cesta+'\'+kde^.jmeno+'\'+maska,anyfile,sr2);
{}                  while doserror=0 do begin
{}                                      assign(f,cesta+'\'+kde^.jmeno+'\'+sr2.name);
{}                                      setfattr(f,jake);
{}                                      findnext(sr2);
{}                                      end;
{}                  if kde^.obsah<>nil then nastavje(kde^.obsah,cesta+'\'+kde^.jmeno);
{}                  kde:=kde^.dalsi;
{}                  end;
{}End;{nastavje}
Begin{hromadneatributy}
getdir(0,pocatecnicesta);
if pocatecnicesta[byte(pocatecnicesta[0])]='\' then dec(byte(pocatecnicesta[0]));{odmazani \}
sa:=nil;
stromadresaru(sa,pocatecnicesta);
nastavje(sa,pocatecnicesta);
zrusstromadresaru(sa);
End;{hromadneatributy}

function Win9XAktivni:boolean; assembler;
Asm
mov AX,$4B21
int $2F
or AH,AH
jz @jsou
 mov AL,false
 jmp @konec
@jsou:
mov AL,true
@konec:
xor AH,AH
End;{win9xaktivni}

END.