(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: RETEZCE.PAS                                                    *)
(*  Obsah: procedury a funkce pro operace s retezci                        *)
(*  Autor: Mircosoft (http://mircosoft.ic.cz)                              *)
(*  Posledni uprava: 31.5.2008                                             *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
unit Retezce;
{$B-}
interface

function KolikCeho(Kolik:byte; Ceho:char):string;
{Vrati retezec vyplneny jednim typem znaku.
 Kolik - delka retezce, Ceho - znak, kterym se ma retezec vyplnit}
function Zarovnej(Co:string; NaKolik:word; Jak:byte; Cim:char):string;
{Vraci dany retezec upraveny na danou delku. Parametry:
 Co - retezec, ktery se ma upravit
 NaKolik - pozadovana delka vysledneho retezce
 Jak - zpusob zarovnani. Mozne hodnoty:                                       }
       const _Doleva=0; _NaStred=1; _Doprava=2;                               {
       Kdyz je retezec kratsi, prodlouzi se. Kdyz je delsi, nic se s nim
       nedela. Pokud ale k Jak prictete konstantu:} _Orezat=4;                {
       bude zkracen.
 Cim - pokud se bude retezec prodluzovat, doplni se temito znaky.}
function NaStr(a:longint):string;
{prevede parametr na retezec}
function NaStr2(a:longint; NaKolik:byte):string;
{to same, ale zadava se i pozadovana delka retezce (zarovnan bude doprava)}
function NaStr3(a:longint; NaKolik:byte):string;
{podobne, ale aby cislo protahla na pozadovanou delku, vklada pred nej nuly}
function NaStrR(a:real; DesMista:byte):string;
{pro realna cisla; zadava se pocet desetinnych mist, sirka zustava vychozi
(nejmensi mozna)}
function LowCase(znak:char):char;
{prevede dane pismeno na male (opak Upcase)}
function StringUp(s:string):string;
{vraci retezec s prevedeny na velka pismena (nebere diakritiku)}
function StringDown(s:string):string;
{vraci retezec s prevedeny na mala pismena (nebere diakritiku)}
function ValF(retezec:string; default:longint):longint;
{Prevede cislo zadane v textu Retezec na ciselnou hodnotu. Pokud se to
nepovede (chyba v zapisu cisla atd.), vrati se hodnota Default, kterou si
zadate dle potreby.}
function Prekoduj(Retezec,PuvodniKodovani,NoveKodovani:string):string;
{Vrati dany Retezec prevedeny z Puvodniho na Nove kodovani. Prevadi pouze
znaky s ceskou diakritikou, zadne speciality jako ohraniceni tabulek, recka
pismena apod. Kodovaci retezce jsou zde:}
const kBezDiakritiky='RISZTCYUNUEDAEOrisztcyunuedaeo';{Nepouzivat jako zdrojove!!!}
      kLatin2='榛ҵ秜Ԡ';{jinak take IBM 852, obvykle standardni znakova sada ceskych verzi DOSu}
      kKamenici='';{kodovani bratru Kamenickych, pouzivaji ho nektere ceske dosove programy}
      kWindows1250='͊횞';{vychozi znakova sada Windows}
      kISO8859_1='RSZTCUNEDrsztcuned';{Nepouzivat jako zdrojove!!! (neobsahuje vsechny znaky)}
      kISO8859_2='ͩ';
{Pokud nezadate spravne PuvodniKodovani, dostanete nesmysl.
Nezkousejte prevod retezce bez diakritiky (nebo v kodovani ISO 8859-1) na
retezec s diakritikou, funkce by ohackovala vsechno, co ohackovat jde.
 Prevadet jde libovolne kodovani, kde 1 byte = 1 znak (Unicode tedy ne, tam je
delka znaku promenna). Vlastni znakovou sadu si muzete vyrobit z hackovanych
a carkovanych pismen v textu 'PRILIS ZLUTOUCKY KUN UPEL DABELSKE ODY prilis
zlutoucky kun upel dabelske ody' bez mezer a presne v tomto poradi.
Poradi i mnozstvi znaku se da zmenit; jedinou podminkou je, ze musi byt
stejne u zdrojoveho i ciloveho kodovaciho retezce.}
function NajdiKonecRadku(Retezec:string; Zacatek,MaxDelka:byte):byte;
{Vrati index posledniho znaku z useku Retezce, ktery zacina indexem Zacatek
a jeho delka nepresahuje hodnotu MaxDelka. Pokud by nejake slovo precuhovalo
za Maxdelku, skonci "radek" uz pred nim. Pouze prilis dlouha slova (delsi nez
Maxdelka) budou rozdelena. Pokud zadate Zacatek vetsi nez je delka retezce,
vrati se nula.}
function OrezMezery(retezec:string; ZeZacatku,ZKonce:boolean):string;
{Vrati zadany retezec zbaveny pocatecnich a/nebo koncovych mezer.}
function xChr(cislo:word):char;
{Pro cisla 0..255 funguje jako standardni Chr, pro cisla >255 vraci #0.}


(*************** nacitani a uchovavani viceradkovych textu: *****************)

type
UkNaRadek = ^tRadek; {tenhle typ pouzivejte k vytvareni promennych}
tRadek = record {tohle je jenom sablona pro spojovy seznam}
         dalsi:UkNaRadek;
         obsah:string;
         end;
{jestli se v tom hodlate vrtat, urcite neprohodte poradi polozek - Obsah musi
byt az na konci. Pro radek se totiz alokuje jen tolik pameti, kolik je zrovna
podle jeho delky potreba, tudiz neni predem dano, kde presne retezec konci
a k cemukoli za nim by neslo normalne (pres tecku) pristupovat.}

procedure NactiTexty(var Kam:uknaradek; Odkud:string; Sirka:byte);
{Za ukazatelem Kam vytvori spojovy seznam radku, ktere nacte z retezce Odkud.
Sirka je pozadovana maximalni sirka radku (ve znacich). Ke kazdemu radku se
vzdycky pridavaji slova tak dlouho, dokud tuto delku neprekroci (pozor,
narozdil od funkce NajdiKonecRadku ji tedy prekrocit muze, ale maximalne o
delku jednoho slova; zadne slovo nebude rozdeleno). Pokud potrebujete
odradkovat rucne, dela se to znakem '|'.
Pokud na cely text nevystaci pamet, ulozi se proste jen tolik radku, na kolik
stacila - zadne chybove hlaseni, zadne ukoncovani programu.
Pro pridavani dalsich radku do jiz hotoveho seznamu se procedura pouzije uplne
stejne (Kam je potom ukazatel na libovolny radek jiz hotoveho seznamu).
 POZOR: pri vytvareni NOVEHO seznamu musi byt ukazatel, ktery predavate v
parametru Kam, bezpodminecne nutne nastaven na NIL, jinak si procedura bude
myslet, ze tam uz nejaky seznam je, pokusi se najit jeho konec (ktery tam
neni), zacne zapisovat do nealokovane pameti a skonci to Nepovolenou Aplikaci!}
function NejdelsiRadek(Ceho:uknaradek):byte;
{Vraci delku nejdelsiho radku v danem seznamu. Pro prazdny seznam vraci 0.}
function PocetRadkuVSeznamu(VeKterem:uknaradek):word;
{vraci pocet radku v danem seznamu}
procedure ZrusTexty(var Ktere:uknaradek);
{zrusi seznam radku, na ktery ukazuje ukazatel Ktere (ten pak bude nil)}

(********************** retezce s neomezenou delkou: ************************)
{O co jde: retezec je tvoren spojovym seznamem kratsich podretezcu (clanku),
takze jeho delka neni omezena ani 255 znaky jako u obycejneho stringu, ani
64 kB jako u retezce ukonceneho znakem #0 (pchar), ale jen velikosti zakladni
pameti (640 kB).}

const ssGranularita=32;{Velikost jednoho clanku superstringu v B. Mel by to
                        byt nasobek 16, aby se zbytecne neplytvalo pameti.}
      ssDelka=ssgranularita-5;{pocet znaku v jednom clanku}

type UkNaKSS = ^kousekss;        {pomocne typy}
     kousekSS = record
                dalsi:uknakss;
                obsah:string[ssdelka];
                end;

Superstring = record {tohle je typ pro vytvareni uzivatelskych promennych}
              delka:longint;{celkovy pocet znaku v celem superstringu dohromady}
              zacatek:uknakss;{ukazatel na prvni clanek}
              fragmentovany:boolean;{true, pokud je delka nekterych clanku (krome posledniho) kratsi nez maximalni
                                     a tudiz v retezci existuji nevyuzite diry}
              end;

procedure ssInit(var Ktery:superstring);
{Inicializuje dany retezec (vynuluje interni promenne). Je nutne to pred
prvnim pouzitim provest!!! (kdyby ukazatel Zacatek nebyl nil, braly by ho
procedury jako zacatek existujiciho retezce a byly by z toho problemy)}
procedure ssVymaz(var Ktery:superstring);
{Vymaze obsah daneho retezce, po provedeni je pripraven k dalsimu pouziti.}
procedure ssPripoj(var KeKteremu,Ktery:superstring);
{Pripoji retezec Ktery na konec retezce KeKteremu a retezec Ktery vymaze.}
procedure ssKopiruj(var Kam,Ktery:superstring);
{retezcem Ktery nahradi obsah retezce Kam, retezec Ktery zustane zachovan}
procedure ssZadej(var Kam:superstring; Co:string);
{Prakticky kam:=co.}
function ssCopy(var Zdroj:superstring; Index:longint; Pocet:byte):string;
{Vrati usek retezce Zdroj dlouhy Pocet znaku a zacinajici na Indextem znaku.}
procedure ssInsert(Co:string; var Kam:superstring; Pozice:longint);
{Do retezce Kam pred znak s indexem Pozice vlozi podretezec Co. Pokud je
Pozice vetsi nez delka retezce Kam, pripoji se Co na jeho konec. Procedura je
vypiplana tak, aby vytvarela co nejmene novych clanku a der, takze je vhodna
treba i pro textove editory, kde se pridava obvykle po jednom znaku.}
procedure ssDelete(var Odkud:superstring; Index,Pocet:longint);
{Z retezce Odkud vymaze usek o delce Pocet znaku pocinaje Indextym. Pokud je
Index mimo rozsah delky retezce Odkud, neprovede se nic.}
procedure ssDefrag(var Ktery:superstring);
{Defragmentuje dany retezec, tj. odstrani vsechny pripadne diry na koncich
jednotlivych clanku a tim uvolni pamet, kterou tyto diry zabiraly.}
procedure ssReadLn(var Odkud:text; var Kam:superstring);
{Z textoveho souboru Odkud (otevreneho pro cteni) nacte jeden radek a ulozi ho
do superstringu Kam. Pokud v Kam neco bylo, bude to napred vymazano.}
procedure ssWriteLn(var Kam:text; var Co:superstring);
{Zapise do textoveho souboru Kam (otevreneho pro zapis) superstring Co a
ukonci radek.}
procedure ssPrekoduj(var Retezec:superstring; PuvodniKodovani,NoveKodovani:string);
{prekoduje ceskou diakritiku v Retezci, viz vyse uvedenou funkci Prekoduj}
function ssNajdiKonecRadku(retezec:superstring; Zacatek:longint; MaxDelka:word):longint;
{funguje prakticky stejne jako funkce NajdiKonecRadku (viz vyse)}

implementation

function kolikceho(kolik:byte;ceho:char):string;
var s:string;
Begin
byte(s[0]):=kolik;{nastaveni delky}
fillchar(s[1],kolik,ceho);{vyplneni obsahu}
kolikceho:=s;{vraceni vysledku}
End;{kolikceho}

function zarovnej(co:string;nakolik:word;jak:byte;cim:char):string;
var orezb:boolean;
Begin
orezb:=jak>=4;{ma se orezavat?}
jak:=jak and 3;{vynulovani "orezavaciho" bitu, aby se na nej nemusel brat ohled pri Case}
if byte(co[0])<nakolik{retezec je kratsi, bude se prodluzovat}
 then case jak of _doleva:co:=co+kolikceho(nakolik-byte(co[0]),cim);{prodlouzime konec retezce}
                  _nastred:begin         {byte(retezec[0])=length(retezec) (aby bylo jasno :-) )}
                           co:=kolikceho((nakolik-byte(co[0])) shr 1,cim)+co;{nejdriv prodlouzit konec o pulku rozdilu...}
                           co:=co+kolikceho((nakolik-byte(co[0])),cim);{...potom zacatek o zbytek}
                           end;
                  _doprava:co:=kolikceho(nakolik-byte(co[0]),cim)+co;{prodlouzime zacatek retezce}
                  end
 else if (byte(co[0])>nakolik)and orezb{retezec je delsi, zkrati se}
             then case jak of _doleva:dec(byte(co[0]),byte(co[0])-nakolik);{uriznuti konce = proste zmenseni jeho delky}
                              _nastred:begin
                                       delete(co,1,(byte(co[0])-nakolik)shr 1);{nejdriv uriznuti zacatku o pul rozdilu...}
                                       dec(byte(co[0]),byte(co[0])-nakolik);{...pak uriznuti konce o zbytek}
                                       end;
                              _doprava:delete(co,1,byte(co[0])-nakolik);{uriznuti znaku ze zacatku}
                              end;
zarovnej:=co;
End;{zarovnej}

function nastr(a:longint):string;
var vysl:string[11];{nejdelsi mozny longint}
Begin
str(a,vysl);
nastr:=vysl;
End;{nastr}

function nastr2(a:longint;nakolik:byte):string;
var vysl:string[80];{snad staci}
Begin
str(a:nakolik,vysl);
nastr2:=vysl;
End;{nastr2}

function NaStr3(a:longint;NaKolik:byte):string;
var vysl:string[80];
Begin
str(a,vysl);
while byte(vysl[0])<nakolik do vysl:='0'+vysl;
nastr3:=vysl;
End;{nastr3}

function NaStrR(a:real;DesMista:byte):string;
var vysl:string[80];
Begin
str(a:0:desmista,vysl);
nastrr:=vysl;
End;{nastrr}

function LowCase(znak:char):char;
Begin
if (znak>='A')and(znak<='Z') then lowcase:=char(byte(znak)+32)
                             else lowcase:=znak;
End;{lowcase}

function stringup(s:string):string;         {by Istk Attila}
var i:byte;
Begin                       {tenhle postup je rychlejsi nez Upcase}
for i:=1 to byte(s[0]){=length(s)} do
 if s[i] in ['a'..'z'] then s[i]:=char(byte(s[i])-32){=chr(ord(...};
stringup:=s;
End;{stringup}

(*Function UpStr(const s:string):string; assembler; {Upper Case String}
{This is the only code that is not mine...}
  asm
    push ds
    lds  si,s
    les  di,@result
    lodsb            { load and store length of string }
    stosb
    xor  ch,ch
    mov  cl,al
    jcxz @empty      { FIX for null length string }
  @upperLoop:
    lodsb
    cmp  al,'a'
    jb   @cont
    cmp  al,'z'
    ja   @cont
    sub  al,' '
  @cont:
    stosb
    loop @UpperLoop
  @empty:
    pop  ds
  end;  { UpStr }*)


function stringdown(s:string):string;       {by Istk Attila}
var i:byte;
Begin
for i:=1 to byte(S[0]) do
 if s[i] in ['A'..'Z'] then s[i]:=char(byte(s[i])+32);
stringdown:=s;
End;{stringdown}

procedure NactiTexty(var kam:uknaradek; odkud:string; sirka:byte);
var pozice:word;{index pro pohyb v retezci Odkud. Word proto, aby nepretekl pri dojeti za konec retezce (>255)}
    radek:string;{pomocny retezec}
    KonecRadku:boolean;{nastavi se na true, pokud se dojelo na konec radku nebo celeho retezce}
    vybrany:uknaradek;{pro pohyb ve spojovem seznamu}
    velikost:word;{velikost prave alokovaneho radku v B}
{}function slovo:string;
{}{vraci slovo prectene ze vstupniho retezce vcetne pripadne mezery za nim, ale bez znaku pro konec radku}
{}var pom:string;
{}    znak:char;
{}Begin
{}pom:='';
{} repeat
{} znak:=odkud[pozice];
{} if znak='|' then konecradku:=true
{}             else pom:=pom+znak;
{} inc(pozice);
{} until (znak=' ')or(znak='|')or(pozice>byte(odkud[0]));
{}if pozice>byte(odkud[0]) then konecradku:=true;
{}slovo:=pom;
{}End;{slovo}
Begin{nactitexty}
if odkud='' then exit;
if kam=nil then vybrany:=nil {seznam zatim neexistuje}
           else begin {seznam jiz existuje => najdeme konec}
                vybrany:=kam;
                while vybrany^.dalsi<>nil do vybrany:=vybrany^.dalsi;
                end;                   {ted Vybrany ukazuje na posledni radek}
pozice:=1;
 repeat {pro kazdy radek}
 radek:=''; konecradku:=false;
 {nacteni radku:}
  repeat
  radek:=radek+slovo;
  until konecradku or(byte(radek[0])>=sirka);
 {uriznuti pripadne mezery z konce radku:}
 if radek[byte(radek[0])]=' ' then dec(byte(radek[0]));
 {potrebne mnozstvi pameti pro ulozeni radku do pameti:}
 velikost:=byte(radek[0])+5;{= delka radku ve znacich (ruzna) + jeho nulty znak (1B) + velikost ukazatele (4B)}
 if velikost>maxavail then exit;{jestli pamet nestaci, tak uz dal ukladat nebudeme}
 {alokace pameti pro radek (trochu netradicne s Getmem misto New):}
 if vybrany=nil then begin{seznam je zatim prazdny}
                     getmem(kam,velikost);{vytvorime prvni radek}
                     vybrany:=kam;{a nasmerujeme na nej pracovni ukazatel}
                     end
                else begin{v seznamu uz neco je}
                     getmem(vybrany^.dalsi,velikost);{vytvorime novy radek za poslednim}
                     vybrany:=vybrany^.dalsi;{a nastavime na nej ukazatel}
                     end;
 vybrany^.dalsi:=nil;{aby bylo jasne, ze to je posledni radek}
 move(radek[0],vybrany^.obsah[0],byte(radek[0])+1);{prekopirovani radku (celeho, od nulteho znaku)}
 until pozice>byte(odkud[0]);{a to vsechno opakujeme, dokud nejsme na konci vstupniho retezce}
End;{nactitexty}

function NejdelsiRadek(Ceho:uknaradek):byte;
var vybrany:uknaradek;
    max:byte;
Begin
vybrany:=ceho; max:=0;
while vybrany<>nil do
  begin
  if byte(vybrany^.obsah[0])>max then max:=byte(vybrany^.obsah[0]);
  vybrany:=vybrany^.dalsi;
  end;
nejdelsiradek:=max;
End;{nejdelsiradek}

function PocetRadkuVSeznamu(VeKterem:uknaradek):word;
var vybrany:uknaradek;
    pocet:word;
Begin
vybrany:=vekterem; pocet:=0;
while vybrany<>nil do begin
                      vybrany:=vybrany^.dalsi;
                      inc(pocet);
                      end;
pocetradkuvseznamu:=pocet;
End;{pocetradkuvseznamu}

procedure ZrusTexty(var ktere:uknaradek);
var vybrany:uknaradek;
    velikost:word;{velikost prave ruseneho radku v B}
Begin
while ktere<>nil do {dokud je co mazat}
  begin
  vybrany:=ktere;{nastavime pomocny ukazatel na prvni radek}
  velikost:=byte(vybrany^.obsah[0])+5;{spocitame velikost}
  ktere:=vybrany^.dalsi;{ukazatel na prvni radek presuneme na nasledujici
       (pokud dojede za konec seznamu, bude mit hodnotu nil a cyklus skonci)}
  freemem(vybrany,velikost);{a vybrany radek smazeme}
  end;
End;{zrustexty}

function ValF(retezec:string; default:longint):longint;
var cislo:longint;
    kod:integer;
Begin
val(retezec,cislo,kod);
if kod=0 then valf:=cislo
         else valf:=default;
End;{valf}

function Prekoduj(Retezec,PuvodniKodovani,NoveKodovani:string):string;
{velice jednoducha a neprilis rychla funkce - necekejte zazraky}
var i,j:byte;
    z:char;
    vysledek:string;
Begin
vysledek[0]:=retezec[0]; {nastaveni delky vysledku rovne delce vstupu}
for i:=1 to length(retezec) do {pro kazdy znak retezce}
 begin
 z:=retezec[i]; {precteme znak z retezce}
 for j:=1 to length(puvodnikodovani) do {projdeme seznam diakritickych znaku...}
   if z=puvodnikodovani[j] then begin {...pokud narazime na hacek nebo carku...}
                                z:=novekodovani[j]; {...nahradime ji prislusnym znakem z cilove znakove sady...}
                                break; {...a ukoncime cyklus for j}
                                end;
 vysledek[i]:=z; {zapiseme prevedeny znak na prislusnou pozici vysledneho textu}
 end;
prekoduj:=vysledek;
End;{prekoduj}

function NajdiKonecRadku(retezec:string; Zacatek,MaxDelka:byte):byte;
var ZacatekSlova,KonecSlova:byte;{indexy pro pohyb v retezci}
Begin
if zacatek>byte(retezec[0]) then begin
                                 najdikonecradku:=0;
                                 exit;
                                 end;
zacatekslova:=zacatek;
konecslova:=zacatek;
 repeat
  repeat {najdeme konec nasledujiciho slova (nebo celeho retezce)}
  inc(konecslova);
  until (konecslova>=byte(retezec[0]))or(retezec[konecslova]=' ');
 if konecslova-zacatek+1<maxdelka{pokud jsme jeste nevycerpali zadanou delku...}
   then zacatekslova:=konecslova {...budeme pokracovat s dalsim slovem...}
   else begin {...jinak koncime}
        if zacatekslova=zacatek then najdikonecradku:=word(zacatek)+maxdelka-1{nasli jsme tak slovo, ktere zacina na zacatku
                                                                           radku, ale nevejde se na nej - musime ho rozdelit}
                                else najdikonecradku:=zacatekslova;{jinak radek ukoncime pred dalsim slovem}
        break;
        end;
 until false; {konci se breakem (grrr...)}
End;{najdikonecradku}

procedure ssInit(var ktery:superstring);
Begin
fillchar(ktery,sizeof(ktery),0);
End;{ssinit}

procedure ssVymaz(var ktery:superstring);
var p:uknakss;
Begin
with ktery do begin
              while zacatek<>nil do begin
                                    p:=zacatek;
                                    zacatek:=zacatek^.dalsi;
                                    dispose(p);
                                    end;
              delka:=0;
              fragmentovany:=false;
              end;
End;{ssvymaz}

procedure ssPripoj(var KeKteremu,Ktery:superstring);
var p:uknakss;
Begin
if ktery.delka<>0 then
 with kekteremu do
  begin
  inc(delka,ktery.delka);
  if zacatek=nil then begin
                      zacatek:=ktery.zacatek;
                      fragmentovany:=ktery.fragmentovany;
                      end
                 else begin
                      p:=zacatek;
                      while p^.dalsi<>nil do p:=p^.dalsi;
                      p^.dalsi:=ktery.zacatek;
                      fragmentovany:=fragmentovany or ktery.fragmentovany or(byte(p^.obsah[0])<ssdelka);
                      end;
  {zruseni Ktereho:}
  ktery.delka:=0;
  ktery.zacatek:=nil;
  ktery.fragmentovany:=false;
  end;
End;{sspripoj}

function ssNovyClanek(var cil:uknakss):boolean;
{Vytori a vynuluje novy clanek superstringu pod zadanym ukazatelem, pokud tedy
na nej je dost pameti. Vraci true, kdyz vsechno dobre dopadne.}
Begin
if maxavail>=ssgranularita {kdyz staci pamet}
  then begin
       new(cil);
       fillchar(cil^,5,0);{nuluje ukazatel na dalsi clanek a delku obsahu}
       ssnovyclanek:=true;
       end
  else ssnovyclanek:=false;
End;{ssnovyclanek}

procedure ssKopiruj(var Kam,Ktery:superstring);
var p,q:uknakss;
Begin
if kam.delka<>0 then ssvymaz(kam);
p:=ktery.zacatek;
while p<>nil do begin
                if kam.zacatek=nil then begin
                                        if not ssnovyclanek(kam.zacatek) then exit;
                                        q:=kam.zacatek;
                                        end
                                   else begin
                                        if not ssnovyclanek(q^.dalsi) then exit;
                                        q:=q^.dalsi;
                                        end;
                move(p^.obsah[0],q^.obsah[0],ssdelka+1);
                p:=p^.dalsi;
                end;
End;{sskopiruj}

procedure ssZadej(var kam:superstring; co:string);
var pocet:byte;{pocet znaku, ktere se v aktualnim kroku kopiruji}
    pozice:word;{pozice ve zdrojovem retezci}
    p:uknakss;{pomocny ukazatel}
Begin
if kam.delka<>0 then ssvymaz(kam);
if co<>'' then
 with kam do
  begin
  fragmentovany:=false;
  pozice:=1;
  if not ssnovyclanek(zacatek) then exit;{kam.delka je ted urcite 0}
  p:=zacatek;
   repeat
   pocet:=byte(co[0])-pozice+1;{kolik znaku zbyva zkopirovat}
   if pocet>ssdelka then begin{zpracujeme jen cast a vytvorime dalsi clanek}
                         move(co[pozice],p^.obsah[1],ssdelka);
                         p^.obsah[0]:=char(ssdelka);
                         inc(pozice,ssdelka);
                         if not ssnovyclanek(p^.dalsi) then begin
                                                            delka:=pozice-1;
                                                            exit;
                                                            end;
                         p:=p^.dalsi;
                         end
                    else begin{dojedeme cely zbytek vstupniho retezce}
                         move(co[pozice],p^.obsah[1],pocet);
                         p^.obsah[0]:=char(pocet);
                         pozice:=0;
                         end;
   until pozice=0;
  delka:=byte(co[0]);{nastaveni delky}
  end;
End;{sszadej}

function ssCopy(var zdroj:superstring; index:longint; pocet:byte):string;
var p:uknakss;
    vysledek:string;
    kolik:byte;
Begin
vysledek:='';
with zdroj do if (pocet>0)and(delka>0)and(index<=delka)and(index>=1) then
  begin
  {nalezeni mista:}
  p:=zacatek;
  while index>byte(p^.obsah[0]) do begin
                                   dec(index,byte(p^.obsah[0]));
                                   p:=p^.dalsi;
                                   end;
  {kopirujeme od p^.obsah[index]:}
   repeat
   {kolik znaku se bude z tohoto clanku kopirovat:}
   kolik:=byte(p^.obsah[0])-index+1;
   if kolik>pocet then kolik:=pocet;
   {kopirovani:}
   vysledek:=vysledek+copy(p^.obsah,index,kolik);
   {ostatni veci:}
   dec(pocet,kolik);
   p:=p^.dalsi;
   index:=1;
   until (pocet=0)or(p=nil);
  end;
sscopy:=vysledek;
End;{sscopy}

procedure ssInsert(co:string; var kam:superstring; pozice:longint);
var p,ZbytekRetezce,predchozi:uknakss;
    PoziceVeZdroji:word;{word proto, aby se zabranilo preteceni pri delce retezce plnych 255 znaku}
    buffer:string[ssdelka];
    pocet:byte;
{}procedure PrectiKousek(JakVelky:byte);{nacte zadany (nebo mensi) pocet znaku
ze vstupniho retezce nebo ulozeneho konce do bufferu}
{}Begin
{}if pozicevezdroji>byte(co[0]) then buffer:=''
{}                              else begin
{}                                   buffer:=copy(co,pozicevezdroji,jakvelky);
{}                                   inc(pozicevezdroji,jakvelky);
{}                                   end;
{}End;{prectikousek}
{}function ZbyvaZnaku:word;{vraci pocet znaku, ktere se jeste budou vkladat}
{}Begin
{}if pozicevezdroji>byte(co[0]) then zbyvaznaku:=0
{}                              else zbyvaznaku:=byte(co[0])-pozicevezdroji+1;
{}End;{zbyvaznaku}
Begin{ssinsert}
if co<>'' then if kam.zacatek=nil then sszadej(kam,co)
                                  else with kam do
   begin
   if pozice<1 then pozice:=1;
   if pozice>delka+1 then pozice:=delka+1;
   pozicevezdroji:=1; buffer:='';
   {nalezeni mista, do ktereho budeme vkladat:}
   p:=zacatek; predchozi:=nil;
   if pozice=delka+1 then begin{na konec}
                          while p^.dalsi<>nil do begin
                                                 predchozi:=p;
                                                 p:=p^.dalsi;
                                                 end;
                          if byte(p^.obsah[0])=ssdelka then begin
                                                            if not ssnovyclanek(p^.dalsi) then exit;
                                                            predchozi:=p;
                                                            p:=p^.dalsi;
                                                            pozice:=1;
                                                            end
                                                       else pozice:=byte(p^.obsah[0])+1;
                          end
                     else begin{nekam doprostred}
                          while pozice>byte(p^.obsah[0]) do
                            begin
                            dec(pozice,byte(p^.obsah[0]));
                            predchozi:=p;
                            p:=p^.dalsi;
                            end;
                          fragmentovany:=true;{sice se muze stat, ze se vlozenim nefragmentuje, ale neni to pravdepodobne}
                          end;
   zbytekretezce:=p^.dalsi;
   {Ted je: p^ - existujici clanek, do ktereho vkladame
            zbytekretezce^ - clanek za p^
            predchozi^ - clanek pred p^
            pozice - index znaku v clanku p^, pred ktery se bude vkladat}
   {pokud mame vkladat pred prvni znak, zkusime to nejdriv vlozit na konec
   predchoziho clanku:}
   if (pozice=1)and(predchozi<>nil)and(byte(predchozi^.obsah[0])<ssdelka)
     then begin
          prectikousek(ssdelka-byte(predchozi^.obsah[0]));{precteni}
          predchozi^.obsah:=predchozi^.obsah+buffer;{zapis}
          if pozicevezdroji>byte(co[0]) then begin
                                             inc(delka,byte(co[0]));{aktualizace delky retezce}
                                             exit;{vesel se tam cely}
                                             end;
          end;
   {pokud se vkladany retezec nevejde do p^, zkusime si v nem udelat misto
   presunutim casti obsahu p^ na konec predchoziho clanku:}
   if (byte(p^.obsah[0])+zbyvaznaku>ssdelka)and(predchozi<>nil)and(byte(predchozi^.obsah[0])<ssdelka)
     then begin
          pocet:=ssdelka-byte(predchozi^.obsah[0]);
          if pocet>byte(p^.obsah[0]) then pocet:=byte(p^.obsah[0]);
          predchozi^.obsah:=predchozi^.obsah+copy(p^.obsah,1,pocet);
          delete(p^.obsah,1,pocet);
          dec(pozice,pocet);
          end;
   {pokud se nyni vkladany retezec vejde cely do p^, vlozime ho tam a koncime:}
   if ssdelka-byte(p^.obsah[0])>=zbyvaznaku
     then begin
          prectikousek(ssdelka);{ve skutecnosti se nejspis nacte mene, coz nevadi}
          insert(buffer,p^.obsah,pozice);
          inc(delka,byte(co[0]));
          exit;
          end;
   {Pokud jsme jeste tady, retezec se do clanku p^ cely nevejde, takze budeme
   muset vytvorit nejake nove clanky.}
   if pozice=1 then if predchozi=nil then begin{uplny zacatek retezce - novy clanek pred p; p a zbytekretezce o pozici zpet}
                                          if not ssnovyclanek(zacatek) then exit;
                                          zacatek^.dalsi:=p;
                                          zbytekretezce:=p;
                                          p:=zacatek;
                                          end
                                     else begin{zacatek nejakeho clanku - novy clanek pred p; p a zbytekretezce o pozici zpet}
                                          if not ssnovyclanek(predchozi^.dalsi) then exit;
                                          predchozi^.dalsi^.dalsi:=p;
                                          zbytekretezce:=p;
                                          p:=predchozi^.dalsi;
                                          end
               else begin{p^ rozdelime a novy clanek vytvorime za nim}
                    if not ssnovyclanek(p^.dalsi) then exit;
                    co:=co+copy(p^.obsah,pozice,ssdelka);{pripoji se jen skutecna delka zbytku clanku}
                    dec(delka,byte(p^.obsah[0])-pozice+1);{aktualizace delky pro pripad predcasneho konce procedury}
                    byte(p^.obsah[0]):=pozice-1;{smazani ulozeneho konce z p^}
                    p:=p^.dalsi;
                    p^.dalsi:=zbytekretezce;
                    {ukazatel Predchozi uz nebude potreba, tak se o nej nestarame}
                    end;
   prectikousek(ssdelka-byte(p^.obsah[0]));
   while buffer<>'' do
     begin
     p^.obsah:=p^.obsah+buffer;
     inc(delka,byte(buffer[0]));
     if byte(p^.obsah[0])=ssdelka then begin
                                       if not ssnovyclanek(p^.dalsi) then exit;
                                       p:=p^.dalsi;
                                       p^.dalsi:=zbytekretezce;
                                       end;
     prectikousek(ssdelka-byte(p^.obsah[0]));
     end;
   end;
End;{ssinsert}

procedure ssDelete(var odkud:superstring; index,pocet:longint);
var p,predchozi:uknakss;
    xmazani:byte;{pocet znaku k smazani z jednoho clanku}
Begin
with odkud do if (pocet>0)and(delka>0)and(index<=delka)and(index>=1) then
  begin
  p:=zacatek; predchozi:=nil;
  while index>byte(p^.obsah[0]) do begin
                                   dec(index,byte(p^.obsah[0]));
                                   predchozi:=p;
                                   p:=p^.dalsi;
                                   end;
  {mazeme od p^.obsah[index]:}
   repeat
   if pocet<=byte(p^.obsah[0])-index+1
     then begin{budeme mazat jen z jednoho clanku}
          delete(p^.obsah,index,pocet);
          dec(delka,pocet);
          pocet:=0;
          if p^.obsah[0]=#0 then begin{vymazali jsme cely obsah clanku p^, tak ho zrusime}
                                 if predchozi=nil then zacatek:=p^.dalsi
                                                  else predchozi^.dalsi:=p^.dalsi;
                                 dispose(p);
                                 end
                            else fragmentovany:=true;{zkracenim clanku na nenulovou delku jsme vytvorili diru}
          end
     else begin{cast smazeme odtud, zbytek z nasledujiciho}
          if index>1 then fragmentovany:=true;{kdyz clanek nesmazeme cely, vznikne v nem dira}
          xmazani:=byte(p^.obsah[0])-index+1;
          dec(pocet,xmazani);
          dec(delka,xmazani);
          index:=1;
          dec(byte(p^.obsah[0]),xmazani);{umazani konce retezce (rychlejsi nez Delete)}
          predchozi:=p;
          p:=p^.dalsi;
          if p=nil then pocet:=0;{uz neni co mazat}
          end;
   until pocet=0;
  end;
End;{ssdelete}

procedure ssDefrag(var ktery:superstring);
var p,xmazani:uknakss;
    pocet:byte;{pro pocitani velikosti der}
Begin
if (ktery.delka>0)and(ktery.fragmentovany) then with ktery do
  begin
  p:=zacatek;
  while p^.dalsi<>nil do
    begin
    if byte(p^.obsah[0])=ssdelka
      then p:=p^.dalsi{OK, tenhle je cely zaplneny, jdeme na dalsi}
      else with p^ do begin{tady je dira}
                      pocet:=ssdelka-byte(obsah[0]);{jak je dira velka?}
                      obsah:=obsah+copy(dalsi^.obsah,1,pocet);{zaplnime diru zacatkem nasledujiciho clanku}
                      delete(dalsi^.obsah,1,pocet);{nekopirujeme, ale presouvame}
                      if dalsi^.obsah[0]=#0 then begin{jestli v tom nasledujicim clanku nic nezbylo, smazeme ho}
                                                 xmazani:=dalsi;
                                                 dalsi:=dalsi^.dalsi;
                                                 dispose(xmazani);
                                                 end;
                      end;
    end;
  fragmentovany:=false;
  end;
End;{ssdefrag}

procedure ssReadLn(var odkud:text; var kam:superstring);
var buffer:string[ssdelka];
    p:uknakss;
Begin
if kam.delka<>0 then ssvymaz(kam);
with kam do
  begin
  fragmentovany:=false;
  buffer:='';{dulezite pro detekci I/O chyb}
  read(odkud,buffer);{Read se o konec radku v souboru zastavi a dal necte}
  while buffer<>'' do begin
                      {Po I/O chybe se dalsi Read neprovede a buffer zustane
                      prazdny. Ioresult zaroven zustane nedotcen a da se
                      zkontrolovat mimo tuto proceduru.
                      Vytvoreni noveho clanku superstringu:}
                      if zacatek=nil then begin
                                          if not ssnovyclanek(zacatek) then exit;
                                          p:=zacatek;
                                          end
                                     else begin
                                          if not ssnovyclanek(p^.dalsi) then exit;
                                          p:=p^.dalsi;
                                          end;
                      p^.obsah:=buffer;{prekopirovani nactenych dat}
                      inc(delka,byte(buffer[0]));{aktualizace delky}
                      buffer:='';
                      read(odkud,buffer);{nacteni dalsi porce textu}
                      end;
  if not eof(odkud) then readln(odkud);{skocime na zacatek dalsiho radku,
          tedy jestli uz nejsme na konci souboru nebo se nevyskytla I/O chyba}
  end;
End;{ssreadln}

procedure ssWriteLn(var kam:text; var co:superstring);
var p:uknakss;
Begin
p:=co.zacatek;
while p<>nil do begin
                write(kam,p^.obsah);
                p:=p^.dalsi;
                end;
writeln(kam);
{I/O chyba zpusobi, ze se do souboru proste nebude nic zapisovat, takze se nic
spatneho nestane. Ioresult zustane nedotcen a muzeme si ho tedy potom
zkontrolovat.}
End;{sswriteln}

procedure ssPrekoduj(var Retezec:superstring; PuvodniKodovani,NoveKodovani:string);
var pom:uknakss;
Begin
pom:=retezec.zacatek;
while pom<>nil do begin
                  pom^.obsah:=prekoduj(pom^.obsah,puvodnikodovani,novekodovani);
                  pom:=pom^.dalsi;
                  end;
End;{ssprekoduj}

function ssNajdiKonecRadku(retezec:superstring; Zacatek:longint; MaxDelka:word):longint;
var ZacatekSlova,KonecSlova:longint;
    uk:uknakss;{ukazatel na clanek}
    poz:byte;{pozice v clanku}
Begin
if zacatek>retezec.delka then begin
                              ssnajdikonecradku:=0;
                              exit;
                              end;
{nalezeni clanku a pozice v nem, ktere odpovidaji zadanemu indexu zacatku:}
uk:=retezec.zacatek;
zacatekslova:=1; poz:=1;
while zacatekslova<zacatek do
 if zacatek-zacatekslova>=byte(uk^.obsah[0])
   then begin
        inc(zacatekslova,byte(uk^.obsah[0]));
        uk:=uk^.dalsi;
        end
   else begin
        poz:=zacatek-zacatekslova+1;
        zacatekslova:=zacatek;
        end;
konecslova:=zacatek;
 repeat
  repeat
  inc(konecslova);
  {tohle je druhy a posledni rozdil oproti vyse uvedene funkci pro obycejny string:}
  inc(poz);
  if poz>byte(uk^.obsah[0]) then begin
                                 uk:=uk^.dalsi;
                                 poz:=1;
                                 end;
  until (konecslova>=retezec.delka)or(uk^.obsah[poz]=' ');
 if konecslova-zacatek+1<maxdelka
   then zacatekslova:=konecslova
   else begin
        if zacatekslova=zacatek then ssnajdikonecradku:=zacatek+maxdelka-1
                                else ssnajdikonecradku:=zacatekslova;
        break;
        end;
 until false;
End;{ssnajdikonecradku}

function OrezMezery(retezec:string; ZeZacatku,ZKonce:boolean):string;
var index:byte;
Begin
if zkonce then while retezec[byte(retezec[0])]=' ' do dec(byte(retezec[0]));
if zezacatku then begin
                  index:=1;
                  while retezec[index]=' ' do inc(index);
                  delete(retezec,1,index-1);
                  end;
orezmezery:=retezec;
End;{orezmezery}

function xChr(cislo:word):char; assembler;
Asm
mov AX,cislo
test AX,$FF00
jz @normalni
 xor AX,AX
@normalni:
{znak je jenom jinak vyjadrene cislo, takze se nemusi nijak prevadet}
End;{xchr}

END.